﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using Telerik.Windows.Controls;

namespace RadCalendarFirstLook_WPF
{
    public class ViewModel : ViewModelBase
    {
        private ObservableCollection<Event> eventsCollection;
        public ObservableCollection<Event> EventsCollection
        {
            get
            {
                return this.eventsCollection;
            }
            set
            {
                this.eventsCollection = value;
                OnPropertyChanged(() => this.EventsCollection);
            }
        }

        private ObservableCollection<Event> filteredEventsCollection;
        public ObservableCollection<Event> FilteredEventsCollection
        {
            get
            {
                return this.filteredEventsCollection;
            }
            set
            {
                this.filteredEventsCollection = value;
                this.NotifyCollectionChanged();
            }
        }

        public ViewModel()
        {
            this.eventsCollection = this.GetCollection();
        }

        public void FilterByDate(IList<DateTime> dates)
        {
            if (this.filteredEventsCollection == null)
            {
                this.filteredEventsCollection = new ObservableCollection<Event>();
            }
            else
            {
                this.filteredEventsCollection.Clear();
            }

            foreach (var date in dates)
            {
                foreach (var evnt in eventsCollection.Where(e => e.Date == date))
                {
                    this.filteredEventsCollection.Add(evnt);
                }
            }

            this.NotifyCollectionChanged();
        }

        private void NotifyCollectionChanged()
        {
            OnPropertyChanged(() => this.FilteredEventsCollection);
        }

        private ObservableCollection<Event> GetCollection()
        {
            var collection = new ObservableCollection<Event>();

            collection.Add(new Event { Day = 1, Title = "The Future Of Web Development", Company = "Telerik Inc - Boston, USA", Description = "Speaker: Tom Black; Start Time - 11.15 AM" });
            collection.Add(new Event { Day = 2, Title = "Blend For Silverlight Developers", Company = "Telerik Inc - Texas, USA", Description = "Speaker: Tom Black; Start Time - 4.00 PM" });
            collection.Add(new Event { Day = 3, Title = "Integrating WPF and WCF", Company = "Telerik Inc - Boston, USA", Description = "Speaker: Tom Wildermuth; Start Time - 1.00 PM" });
            collection.Add(new Event { Day = 4, Title = "What's new in WCF 4", Company = "Telerik Inc - Boston, USA", Description = "Speaker: Grace Becerra; Start Time - 10.00 AM" });

            collection.Add(new Event { Day = 4, Title = "The Future Of Web Development", Company = "Telerik Inc - Boston, USA", Description = "Speaker: Tom Black; Start Time - 11.15 AM" });
            collection.Add(new Event { Day = 3, Title = "Blend For Silverlight Developers", Company = "Telerik Inc - Texas, USA", Description = "Speaker: Tom Black; Start Time - 4.00 PM" });
            collection.Add(new Event { Day = 2, Title = "Integrating WPF and WCF", Company = "Telerik Inc - Boston, USA", Description = "Speaker: Tom Wildermuth; Start Time - 1.00 PM" });
            collection.Add(new Event { Day = 1, Title = "What's new in WCF 4", Company = "Telerik Inc - Boston, USA", Description = "Speaker: Grace Becerra; Start Time - 10.00 AM" });

            return collection;
        }
    }
}
